/*
 ********************************************************************************
 *
 *  _ W D M D R V . H
 *
 *  Purpose:
 *      Demonstrate how a VxD driver can call into WDM in order to preserve 
 *      existing VxD API interface
 *  
 *      This file contains #defines and structures private to wdmdrv.c 
 *
 *  Copyright 1997  Microsoft Corp.
 *
 *  Author:     Dr. Iver
 *
 *
 ********************************************************************************
 */
#ifdef DBG  // WDM DDK build enviornment uses DBG
#define DEBUG
#endif 

#ifdef  DEBUG
    extern UINT dbgOpt;

    #define DBGOUT(msg_in_parens) if (dbgOpt) { DbgPrint("\r\nWDMDRV> "); DbgPrint msg_in_parens; DbgPrint("\r\n"); }
    #define DBGERR(msg_in_parens) { DbgPrint("\r\n *** WDMDRV ERROR *** \r\nWDMDRV> "); DbgPrint msg_in_parens; DbgPrint("\r\n"); }
    #define DBGBREAK() { _asm { int 3 } }

    #undef ASSERT
    #define ASSERT(x) if (!(x)){ DBGERR(("Assertion failed:" #x)); DBGBREAK(); }

#else
    #define DBGOUT(msg_in_parens)
    #define DBGERR(msg_in_parens)
    #define DBGBREAK()
#endif

#ifdef DEBUG
#define MOUSE_DATA_TAG 0x99999999
#endif 

//
// main data structure which maintains state of an open usb mouse
// 
typedef struct tag_HidMouseData {
#ifdef DEBUG
                    ULONG  tag;         // tag will be filled in MOUSE_DATA_TAG
                                        // to verify structure integrity
#endif
                    HANDLE devHandle;               // handle to hid device  
                    PUCHAR report;
                    LARGE_INTEGER dataLength;
                    HIDP_CAPS hidCapabilities;
                    PHIDP_VALUE_CAPS valueCaps;
                    PHIDP_PREPARSED_DATA hidDescriptor;
                    IO_STATUS_BLOCK ioStatusBlock;
                    WORK_QUEUE_ITEM workItemRead;
                    UINT buttonListLength;
                    PUSAGE buttonValues;
                    UINT buttonStatus;
                    KEVENT eWaitForComplete;    // Operation completed event
                    NTSTATUS LastStatus;
                    WCHAR deviceFileName[(MAXIMUM_FILENAME_LENGTH*sizeof(WCHAR))+sizeof(UNICODE_NULL)];
                    PWORK_QUEUE_ITEM    pWorkItemOpen;
                    PWORK_QUEUE_ITEM    pWorkItemClose;
                    BOOL bIsClosing;            // Is this mouse in process of closing?
} HID_MOUSE_DATA, *LPHID_MOUSE_DATA;



